package itz.estadistica;

import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;

import javax.swing.JPanel;
import javax.swing.border.LineBorder;
import java.awt.Color;
import javax.swing.JLabel;
import java.awt.Font;
import javax.swing.JList;
import javax.swing.JOptionPane;
import javax.swing.JScrollPane;
import javax.swing.DefaultListModel;
import javax.swing.JButton;
import javax.swing.ScrollPaneConstants;

public class JEstadistica extends JPanel implements ActionListener{

	/**
	 * 
	 */
	private static final long serialVersionUID = 1L;
	private JLabel lblEstadistica;
	private JScrollPane scrollPane;
	private JList<Double> lstValores;
	private JButton btnAgregar,btnEliminar,btnMediaAritmetica,btnDesviacinEstandar;
	private DefaultListModel<Double> lista=new DefaultListModel<Double>();
	
	/**
	 * Create the panel.
	 */
	public JEstadistica() {
		setBorder(new LineBorder(new Color(0, 0, 255), 4, true));
		setLayout(null);
		
		lblEstadistica = new JLabel("Estadistica");
		lblEstadistica.setFont(new Font("Arial", Font.BOLD, 15));
		lblEstadistica.setBounds(108, 13, 94, 16);
		add(lblEstadistica);
		
		scrollPane = new JScrollPane();
		scrollPane.setHorizontalScrollBarPolicy(ScrollPaneConstants.HORIZONTAL_SCROLLBAR_NEVER);
		scrollPane.setBounds(12, 49, 150, 226);
		add(scrollPane);
		
		lstValores = new JList<Double>();
		lstValores.setModel(lista);
		scrollPane.setViewportView(lstValores);
		
		btnAgregar = new JButton("Agregar");
		btnAgregar.setBounds(183, 62, 97, 25);
		btnAgregar.addActionListener(this);
		add(btnAgregar);
		
		btnEliminar = new JButton("Eliminar");
		btnEliminar.setBounds(183, 110, 97, 25);
		btnEliminar.addActionListener(this);
		add(btnEliminar);
		
		btnMediaAritmetica = new JButton("Media Aritmetica");
		btnMediaAritmetica.setBounds(183, 164, 129, 25);
		btnMediaAritmetica.addActionListener(this);
		add(btnMediaAritmetica);
		
		btnDesviacinEstandar = new JButton("Desviaci\u00F3n Estandar");
		btnDesviacinEstandar.setBounds(183, 213, 147, 25);
		btnDesviacinEstandar.addActionListener(this);
		add(btnDesviacinEstandar);

	}

	@Override
	public void actionPerformed(ActionEvent e) {
		if (e.getSource()==btnAgregar) {
			try {
				double x=Double.parseDouble(JOptionPane.showInputDialog("Teclea un valor:"));
				lista.addElement(x);
			} catch (Exception ex) {
				JOptionPane.showMessageDialog(null, "Se esperaba un valor numerico");
			}
		}
		if (e.getSource()==btnEliminar) {
			int pos=lstValores.getSelectedIndex();
			if (pos>=0) lista.remove(pos);
		}
		if (e.getSource()==btnMediaAritmetica) {
			double media=Estadistica.mediaAritmetica(lista);
			JOptionPane.showMessageDialog(null, "La media aritmetica es:"+media);
		}
		if (e.getSource()==btnDesviacinEstandar) {
			double des=Estadistica.desviacionEstandar(lista);
			JOptionPane.showMessageDialog(null, "La desviacin estandar es:"+des);
		}
	}
}
